![logo](https://github.com/r3shape/koncept/blob/main/koncept/assets/r3-sticker.png?raw=true)  
![PyPi Package version](https://img.shields.io/pypi/v/r3frame?style=for-the-badge&logo=pypi&logoColor=white&label=r3frame&labelColor=black&color=white&link=https%3A%2F%2Fpypi.org%2Fproject%2Fr3frame%2F2025.0.2%2F
)  
![GitHub Stars](https://img.shields.io/github/stars/r3shape/r3frame?style=for-the-badge&label=stars&labelColor=black&color=white)
![License](https://img.shields.io/badge/mit-badge?style=for-the-badge&logo=mit&logoColor=white&label=License&labelColor=black&color=white)

## What is r3frame?  
**r3frame** is a game development framework designed to help developers create games with **more speed and less hassle**. It provides a structured foundation for handling scenes, objects, UI, input, and rendering, so you can focus on making games instead of reinventing the wheel.  

## Why Use r3frame?  
- **Save Time** – No need to build a game structure from scratch.  
- **Better Organization** – Scenes, assets, and objects are neatly managed.  
- **Pygame, but Better** – All the flexibility of Pygame, with added convenience.  

## Features  
- **Modularity** – Manage your game with a clean and modular API.  
- **Scene & Object Management** – Easily define and switch between game scenes.  
- **Custom UI System** – Buttons, text fields, and interface-scripting made simple.  
- **Asset Loading** – Load images and sprite sheets efficiently.  
- **Input Handling** – Keyboard and mouse events with built-in support.  
- **Partitioning Systems** – Efficient object management for game worlds of many sizes.  

## Installation  
Install **r3frame** via pip:  

```sh
pip install r3frame
```

## Contributing  
Want to help improve **r3frame**? Feel free to contribute by submitting issues, suggesting features, or making pull requests!  

## License  
**r3frame** is open-source under the **MIT License.**
